#include <bits/stdc++.h>
#include <experimental/random>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using str = string;
using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>;

const ll INF = 1e18, MOD = 1e9 + 7;

void solve();

signed main() {
#ifdef LOCAL
    freopen("output.txt","w",stdout);
    freopen("input.txt","r",stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int test = 1;
    //cin >> test;
    while (test--) {
        solve();
    }
}

vector<vector<int>> g;

void solve() {
    int n, m, k;
    cin >> n >> m >> k;
    g.resize(n);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    set<pair<int, int>> u;
    vector<bool> us(n);
    for (int i = 0; i < k; ++i) {
        int p, h;
        cin >> p >> h;
        p--;
        u.insert({-h, p});
    }
    int cnt = 0;
    vector<bool> us1(n);
    vector<int> ans;
    while (u.size() != 0) {
        auto x = *u.begin();
        u.erase(x);
        if (us1[x.second] || x.first > 0) {
            continue;
        }
        cnt++;
        ans.push_back(x.second);
        us[x.second] = true;
        us1[x.second] = true;
        for (int i = 0; i < g[x.second].size(); ++i) {
            int to = g[x.second][i];
            if (!us[to]) {
                us[to] = true;
                u.insert({x.first + 1, to});
            }
        }
    }
    cout << cnt << "\n";
    sort(ans.begin(), ans.end());
    for (int i = 0; i < ans.size(); ++i) {
        cout << ans[i] + 1 << " ";
    }
}