#include <bits/stdc++.h>
#include <experimental/random>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using str = string;
using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>;

const ld INF = 1e18, MOD = 1e9 + 7;

void solve();

signed main() {
#ifdef LOCAL
    freopen("output.txt","w",stdout);
    freopen("input.txt","r",stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll test = 1;
    //cin >> test;
    while (test--) {
        solve();
    }
}

struct vec {
    ld x, y;
};
ld ans = 1e18;

void solve(vector<vector<ld>> g) {
    ld n = g.size();
    ld o = 1;
    vector<int> st;
    for (ld i = 0; i < n; ++i) {
        st.push_back(o);
        o *= 2;
    }
    vector<vector<ll>> pos(n + 1);
    for (ld i = 0; i < o; ++i) {
        ll i1 = i;
        ld cnt = 0;
        for (ld j = 0; j < n; ++j) {
            if (i1 % 2 == 1) {
                cnt++;
            }
            i1 /= 2;
        }
        pos[cnt].push_back(i);
    }
    vector<vector<ld>> dp(o, vector<ld>(n, INF));

    for (ld i = 0; i < pos[1].size(); ++i) {
        ll u = pos[1][i];
        int x = 0;
        for (int j = 0; j < n; ++j) {
            if ((u >> j) % 2 == 1) {
                x = j;
                break;
            }
        }
        dp[u][x] = 0;
        for (int j = 0; j < n; ++j) {
            if ((u >> j) % 2 == 0) {
                ll u1 = u + st[j];
                dp[u1][j] = min(dp[u1][j], g[x][j]);
            }
        }
    }
    for (int i = 2; i < n; ++i) {
        for (auto u: pos[i]) {
            for (int j = 0; j < n; ++j) {
                if (dp[u][j] != INF) {
                    int u1 = u;
                    for (int k = 0; k < n; ++k) {
                        if ((u1 >> k) % 2 == 0) {
                            dp[u1 + st[k]][k] = min(dp[u1 + st[k]][k], dp[u1][j] + g[j][k]);
                        }
                    }
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        ans = min(ans, dp[o - 1][i]);
    }
}

void solve() {
    ll n;
    cin >> n;
    vector<vec> q;
    q.resize(n);
    for (ld i = 0; i < n; ++i) {
        cin >> q[i].x >> q[i].y;
    }
    for (ld i = 0; i < n; ++i) {
        for (ld j = i + 1; j < n; ++j) {
            ld x = q[i].x - q[j].x;
            ld y = q[i].y - q[j].y;
            ld xx = -y;
            ld yy = x;
            vector<vector<ld>> h(n, vector<ld>(n));
            for (ld k = 0; k < n; ++k) {
                for (ld l = k + 1; l < n; ++l) {
                    ld x1 = q[k].x;
                    ld y1 = q[k].y;
                    ld x2 = x1 + x;
                    ld y2 = y1 + y;
                    ld a = y2 - y1;
                    ld b = x1 - x2;
                    ld c = x2 * y1 - x1 * y2;
                    ld x3 = q[l].x;
                    ld y3 = q[l].y;
                    ld u = abs((x3 * a + y3 * b + c)) / sqrt(a * a + b * b);
                    x1 = q[k].x;
                    y1 = q[k].y;
                    x2 = x1 + xx;
                    y2 = y1 + yy;
                    a = y2 - y1;
                    b = x1 - x2;
                    c = x2 * y1 - x1 * y2;
                    x3 = q[l].x;
                    y3 = q[l].y;
                    ld u1 = abs((x3 * a + y3 * b + c)) / sqrt(a * a + b * b);
                    h[k][l] = u + u1;
                    h[l][k] = u + u1;
                }
            }
            solve(h);
        }
    }
    cout<<fixed<<setprecision(30);
    cout << ans;
}